# Initialization


# LOCAL ENVIRONMENT
# EDIT LOCATION OF BINARIES

## DWB, 25-MAR-2004
## Set up for the correct computer platform auto-magically.

switch [string toupper [string range $tcl_platform(os) 0 4]] {

LINUX
{
 puts [concat "\nInitiating ComoUI for " $tcl_platform(os) "\n"]
# Edit the next two lines to point to the correct como executable & browser locations.
 set como(COMOBIN) /home/xray/como/Linux70/como
 set como(BROWSER) /usr/bin/netscape
}

IRIX6
{
 puts [concat "\nInitiating ComoUI for " $tcl_platform(os) "\n"]
# Edit the next two lines to point to the correct como executable & browser locations.
 set como(COMOBIN) /home/xray/como/Irix63/como
 set como(BROWSER) /usr/bin/X11/netscape
}

default
{
 tk_messageBox -icon error \
 -message [concat "Don't know how to initiate ComoUI for operating system " $tcl_platform(os) "  - exiting..."] \
 -title "ComoUI Error" -type ok
 exit 1
}
}


# DO NOT EDIT BELOW
####################
# Interface variables

set como(MODE) novice
set como(PANEL) general
set como(MSWITCH) P
set como(BOVERSWITCH) 1
set como(CELLSWITCH) 0
set como(SFSWITCH) 0
set como(ROOTNAME) como
set como(SET_FORMAT) hkl
set como(CLOSEMESS) 0
set como(COLOR) #ffaa00
set como(PID) -1

# General Input Block

set keyword(TITLE) project
# Angle conventions
set keyword(POLAR) xzk
set keyword(EULER) zyz
set keyword(ORTHOG) axabz

# Crystal Input Block

set keyword(CELL1) 76.7
set keyword(CELL2) 96.1
set keyword(CELL3) 111.3
set keyword(CELL4) 90
set keyword(CELL5) 97.1
set keyword(CELL6) 90
set keyword(SYMMETRY) P21
set keyword(FOBSFILE) 3eca.cal
set keyword(FORMAT) hkl
set keyword(POWER) 1
set keyword(SPECIFY_FORMAT) "3i4,2f8.2"
set keyword(RESOLUTION1) 10.0
set keyword(RESOLUTION2) 4.0
# Crystal advanced
set keyword(REJECT1) 1.0
set keyword(REJECT2) 1.0
set keyword(REJECT3) 0.0
set keyword(PHASE) F

# Model information
set keyword(BOVER) 25
set keyword(FAMILY) member.dat
set keyword(CENTER) T
set keyword(MFLAG) U
set keyword(COPY) 1
set keyword(CELL) 100
set keyword(INPUT) model.pdb

# RF
set keyword(RCUTOFF1) 0.25
set keyword(RCUTOFF2) 0.5
set keyword(NORM1) true
set keyword(NORM2) 8
set keyword(SANGLE) euler
set keyword(ORIGIN) true
set keyword(RADIUS) -1
set keyword(RSAVE) 10
set keyword(SKIP) F
set keyword(RRESOLUTION1) 10.0
set keyword(RRESOLUTION2) 4.0
set keyword(GRIDRF) 1

# TF
set keyword(TCUTOFF1) 2
set keyword(TCUTOFF2) 0.5
set keyword(DCUT1) 3 
set keyword(DCUT2) 3
set keyword(DCUT3) 1
set keyword(TSAFE1) 20 
set keyword(TSAFE2) true
set keyword(SOLUTION) 1 
set keyword(TFLAG) A
set keyword(TRESOLUTION1) 8
set keyword(TRESOLUTION2) 4

# COMO
set keyword(1) 0.7 
set keyword(2) 1
set keyword(11) 0.8 
set keyword(12) 1 
set keyword(21) 0.7
set keyword(22) 1
set keyword(31) 0.7 
set keyword(32) 1
set keyword(41) 0.7 
set keyword(42) 1
set keyword(51) 0.7 
set keyword(52) 1

# Solution

set keyword(SOLFILE) soln.pdb
set keyword(SDCUT) 3

# Sfcalc

set keyword(SFFILE) fcalc.dat
set keyword(SFRESOLUTION1) 20
set keyword(SFRESOLUTION2) 3











