proc Comoexit {} {

    global como
    global keyword

    if [catch {open .comoui w} stat] {
	puts stderr "Could not write como status file, exiting anyway."
	exit 1
    }

    puts $stat ""
    puts $stat "# Initialization"
    puts $stat ""
    puts $stat "# Interface variables"
    puts $stat ""
    puts $stat "set como(MODE) $como(MODE)"
    puts $stat "set como(MSWITCH) $como(MSWITCH)"
    puts $stat "set como(BOVERSWITCH) $como(BOVERSWITCH)"
    puts $stat "set como(CELLSWITCH) $como(CELLSWITCH)"
    puts $stat "set como(SFSWITCH) $como(SFSWITCH)"
    puts $stat "set como(COMOBIN) $como(COMOBIN)"
    puts $stat "set como(BROWSER) $como(BROWSER)"
    puts $stat "set como(ROOTNAME) $como(ROOTNAME)"
    puts $stat "set como(SET_FORMAT) $como(SET_FORMAT)"
    puts $stat "set como(CLOSEMESS) 0"
    puts $stat "set como(COLOR) $como(COLOR)"
    puts $stat "set como(PID) $como(PID)"
    puts $stat ""
    puts $stat "# General Input Block"
    puts $stat ""
    puts $stat "set keyword(TITLE) $keyword(TITLE)"
    puts $stat "# Angle conventions"
    puts $stat "set keyword(POLAR) $keyword(POLAR)"
    puts $stat "set keyword(EULER) $keyword(EULER)"
    puts $stat "set keyword(ORTHOG) $keyword(ORTHOG)"
    puts $stat ""
    puts $stat "# Crystal Input Block"
    puts $stat ""
    puts $stat "set keyword(CELL1) $keyword(CELL1)"
    puts $stat "set keyword(CELL2) $keyword(CELL2)"
    puts $stat "set keyword(CELL3) $keyword(CELL3)"
    puts $stat "set keyword(CELL4) $keyword(CELL4)"
    puts $stat "set keyword(CELL5) $keyword(CELL5)"
    puts $stat "set keyword(CELL6) $keyword(CELL6)"
    puts $stat "set keyword(SYMMETRY) $keyword(SYMMETRY)"
    puts $stat "set keyword(FOBSFILE) $keyword(FOBSFILE)"
    puts $stat "set keyword(FORMAT) \"$keyword(FORMAT)\""
    puts $stat "set keyword(POWER) $keyword(POWER)"
    puts $stat "set keyword(RESOLUTION1) $keyword(RESOLUTION1)"
    puts $stat "set keyword(RESOLUTION2) $keyword(RESOLUTION2)"
    puts $stat "# Crystal advanced"
    puts $stat "set keyword(SPECIFY_FORMAT) $keyword(SPECIFY_FORMAT)"
    puts $stat "set keyword(REJECT1) $keyword(REJECT1)"
    puts $stat "set keyword(REJECT2) $keyword(REJECT2)"
    puts $stat "set keyword(REJECT3) $keyword(REJECT3)"
    puts $stat "set keyword(PHASE) $keyword(PHASE)"
    puts $stat ""
    puts $stat "# Model information"
    puts $stat "set keyword(BOVER) $keyword(BOVER)"
    puts $stat "set keyword(FAMILY) $keyword(FAMILY)"
    puts $stat "set keyword(CENTER) $keyword(CENTER)"
    puts $stat "set keyword(MFLAG) $keyword(MFLAG)"
    puts $stat "set keyword(COPY) $keyword(COPY)"
    puts $stat "set keyword(CELL) $keyword(CELL)"
    puts $stat "set keyword(INPUT) $keyword(INPUT)"
    puts $stat ""
    puts $stat "# RF"
    puts $stat "set keyword(RCUTOFF1) $keyword(RCUTOFF1)"
    puts $stat "set keyword(RCUTOFF2) $keyword(RCUTOFF2)"
    puts $stat "set keyword(NORM1) $keyword(NORM1)"
    puts $stat "set keyword(NORM2) $keyword(NORM2)"
    puts $stat "set keyword(SANGLE) $keyword(SANGLE)"
    puts $stat "set keyword(ORIGIN) $keyword(ORIGIN)"
    puts $stat "set keyword(RADIUS) $keyword(RADIUS)"
    puts $stat "set keyword(RSAVE) $keyword(RSAVE)"
    puts $stat "set keyword(SKIP) $keyword(SKIP)"
    puts $stat "set keyword(RRESOLUTION1) $keyword(RRESOLUTION1)"
    puts $stat "set keyword(RRESOLUTION2) $keyword(RRESOLUTION2)"
    puts $stat "set keyword(GRIDRF) $keyword(GRIDRF)"
    puts $stat ""
    puts $stat "# TF"
    puts $stat "set keyword(TCUTOFF1) $keyword(TCUTOFF1)"
    puts $stat "set keyword(TCUTOFF2) $keyword(TCUTOFF2)"
    puts $stat "set keyword(DCUT1) $keyword(DCUT1)"
    puts $stat "set keyword(DCUT2) $keyword(DCUT2)"
    puts $stat "set keyword(DCUT3) $keyword(DCUT3)"
    puts $stat "set keyword(TSAFE1) $keyword(TSAFE1)" 
    puts $stat "set keyword(TSAFE2) $keyword(TSAFE2)"
    puts $stat "set keyword(SOLUTION) $keyword(SOLUTION)" 
    puts $stat "set keyword(TFLAG) $keyword(TFLAG)"
    puts $stat "set keyword(TRESOLUTION1) $keyword(TRESOLUTION1)"
    puts $stat "set keyword(TRESOLUTION2) $keyword(TRESOLUTION2)"
    puts $stat ""
    puts $stat "# COMO"
    
    for {set i 1} {$i <= $keyword(COPY)} {incr i} {
	
	set faa [expr [expr $i * 10] - 9]
	set fab [expr [expr $i * 10] - 8]
	
	puts $stat "set keyword($faa) $keyword($faa)" 
	puts $stat "set keyword($fab) $keyword($fab)"
    }
    puts $stat ""
    puts $stat "# Solution"
    puts $stat ""
    puts $stat "set keyword(SOLFILE) $keyword(SOLFILE)"
    puts $stat "set keyword(SDCUT) $keyword(SDCUT)"
    puts $stat ""
    puts $stat "# Sfcalc"
    puts $stat ""
    puts $stat "set keyword(SFFILE) $keyword(SFFILE)"
    puts $stat "set keyword(SFRESOLUTION1) $keyword(SFRESOLUTION1)"
    puts $stat "set keyword(SFRESOLUTION2) $keyword(SFRESOLUTION2)"
    

    close $stat
    exit
}


proc Go {} {

    global como
    global keyword
    global como_mess
    
    if {[info exists como_mess]} {
	destroy $como_mess
    }

    if {[file exists "$como(ROOTNAME).log"]} {

	
	if {$como(PID) != "-1"} {


	    catch {[exec ps -p $como(PID)]} output 

	    # job is not running

	    if { [regexp (como) $output] == 0} {
		
		# last jobs has terminated in between

		set como(PID) "-1"
		set answer [tk_dialog .test "Job Done"\
			"Examine current logfile or rerun job?" questhead\
			0 "Examine" "Rerun"]
		
		if {$answer == "0"} {
		    CatLog
		    return
		} else {

		    
if {[CheckInputs]} {
return
}
			WriteScriptFile
		    RunScript
		    return
		}
	    } else {    

		# else process is still running

		tk_messageBox -icon info -message "Last job still running."\
			-title "ComoUI Info" -type ok
		CatLog
		return
	    }
	}
    }

if {[CheckInputs]} {
return
}
    WriteScriptFile
    RunScript 
}

proc CheckInputs {} {

global como
global keyword

# check como binary existence

if {![file exists $como(COMOBIN)]} {
		tk_messageBox -icon error -message "Como binary not found :-("\
			-title "ComoUI Info" -type ok
		return 1
}

# check hkl file existence

if {![file exists $keyword(FOBSFILE)]} {
		tk_messageBox -icon error -message "Reflection file not found :-("\
			-title "ComoUI Info" -type ok
		return 1

}

# check model/family file existence

if { $como(MSWITCH) == "P" } {
if {![file exists $keyword(INPUT)]} {
		tk_messageBox -icon error -message "Model file not found :-("\
			-title "ComoUI Info" -type ok
		return 1

}
}
if { $como(MSWITCH) == "F" } {
if {![file exists $keyword(FAMILY)]} {
		tk_messageBox -icon error -message "Family file not found :-("\
			-title "ComoUI Info" -type ok
		return 1

}
}

return 0
}

proc CatLog {} {

    global como
    global como_messages_text
    global como_mess

    #como run messages window
    set como_mess [toplevel .como_messages]
    wm title .como_messages "Como Messages"
    set como_messages [frame $como_mess.messages]
    
    set scroll [scrollbar $como_messages.yscroll -command {$como_messages_text\
	    yview} -orient vertical]
    
    set como_messages_text [text $como_messages.text -width 100 -height 40\
	    -yscrollcommand [list $scroll set]]
    
    set bframe [frame $como_messages.bframe]
    set bframe_dis [button $bframe.dis -text "Close Window"\
	    -command "CloseMess exam"]
    set bframe_abort [button $bframe.abort -text "Abort Job & Close"\
	    -command "AbortRun exam"]
    set bframe_finish [button $bframe.finish -text "Finish asap"\
	    -command FinishJob]
    pack $bframe_dis $bframe_abort $bframe_finish -side left
    grid $como_messages_text $scroll -sticky news
    grid $bframe -sticky news
    pack $como_messages

    catch {set read [open "$como(ROOTNAME).log" r]} {

	tk_messageBox -icon error -message "Current log file not found!"\
		-title "ComoUI Error" -type ok

    }

    while {[gets $read line] >= 0} {

	$como_messages_text insert end "$line \n"
	$como_messages_text see end
    }
    close $read
}


proc WriteScriptFile { } {

    global como
    global keyword
    
    if [catch {open como.inp w} out] {
	puts stderr "Could not write como input file, exiting."
	exit 1
    }

    puts $out "title $keyword(TITLE)"
    puts $out "print $como(ROOTNAME).prt"
    puts $out "polar $keyword(POLAR)"
    puts $out "euler $keyword(EULER)"
    puts $out "orthog $keyword(ORTHOG)"
    puts $out "!"

    puts $out "crystal"
    puts $out "    symmetry $keyword(SYMMETRY)"
    puts $out "    cell $keyword(CELL1) $keyword(CELL2) $keyword(CELL3) \
	    $keyword(CELL4) $keyword(CELL5) $keyword(CELL6) "
    puts $out "    fobs $keyword(FOBSFILE)"
    puts $out "    format $keyword(FORMAT)"

    if {$keyword(FORMAT) == "hkl"} {
	puts $out "    power 1"
    } else {
	puts $out "    power $keyword(POWER)"
    }
    puts $out "    resolution $keyword(RESOLUTION1) $keyword(RESOLUTION2)"
    puts $out "    frejection $keyword(REJECT1) $keyword(REJECT2) \
	    $keyword(REJECT3) "
    puts $out "end"
    
    puts $out "!"
    puts $out "model"
    if {$como(BOVERSWITCH) == 1} {
	puts $out "    bover $keyword(BOVER)"
    }
    if {$como(MSWITCH) == "F"} {
	puts $out "    family $keyword(FAMILY)"
    }
    if {$como(MSWITCH) == "P"} {
	puts $out "    input $keyword(INPUT)"
    }
    if {$keyword(CENTER) == "T"} {
	puts $out "    center"
    }
    puts $out "    copy $keyword(COPY)"
    if {$como(CELLSWITCH) == 1} {
    puts $out "    cell $keyword(CELL)"
    }
    puts $out "    flag $keyword(MFLAG)"
    puts $out "end"
    
    puts $out "!"
    puts $out "rf"
    puts $out "    cutoff $keyword(RCUTOFF1) $keyword(RCUTOFF2)"
    if {$keyword(ORIGIN) == "true"} {
	puts $out "    origin true"
    }
    if {$keyword(NORM1) == "true"} {
	puts $out "    norm true $keyword(NORM2)"
    }
    puts $out "    radius $keyword(RADIUS)"
    puts $out "    resolution $keyword(RRESOLUTION1) $keyword(RRESOLUTION2)"
    puts $out "    save $keyword(RSAVE)"
    puts $out "    grid $keyword(GRIDRF)"
    puts $out "end"

    puts $out "!"
    puts $out "tf"
    puts $out "    resolution $keyword(TRESOLUTION1) $keyword(TRESOLUTION2)"
    puts $out "    cutoff $keyword(TCUTOFF1) $keyword(TCUTOFF2)"
    puts $out "    dcut $keyword(DCUT1)"

    puts $out "!"
    puts $out "!Reduce the cutoff criterion to select more rotation angles"
    for {set i 1} {$i <= $keyword(COPY)} {incr i} {
	set faa [expr [expr $i * 10] - 9]
	set fab [expr [expr $i * 10] - 8]
	
	puts $out "    select $keyword($faa) $keyword($fab)"
	
    }
    puts $out "!"
    puts $out "    finish como.fin"
    puts $out "!   Use the unix command 'touch como.fin' to stop the search"
    puts $out "!   if the correct solution has been found."
    puts $out "!"
    puts $out "end"

    puts $out "!"
    puts $out "solution"
    puts $out "    file $keyword(SOLFILE)"
    puts $out "    dcut $keyword(SDCUT)"
    puts $out "end"

    if { $como(SFSWITCH) == "1"} {
	puts $out "sfcal"
	puts $out "    file $keyword(SFFILE)"
	puts $out "    resolution $keyword(SFRESOLUTION1) $keyword(SFRESOLUTION2)"
	puts $out "end"
    }
    puts $out "!"
    puts $out "stop"
    close $out

#end of writescriptfile
}


# como log file related procedures
#----------------------------------------
proc Reader { pipe } {

    global como_messages_text
    global como

    if {$como(CLOSEMESS) == "1"} {

	set como(CLOSEMESS) 0
	set pids [pid $pipe]
	exec kill -1 $pids
	catch {close $pipe}
	return
    }
    if [eof $pipe] {
	catch {close $pipe}
	return
    }
    if {[gets $pipe line] < 0} {

    } else {
	$como_messages_text insert end "$line \n"
	$como_messages_text see end
    }
}

proc CloseMess { flag } {

    global como_mess
    global finish
    global como
    global pipe

    destroy $como_mess
    if {$flag == "job"} {
	set como(CLOSEMESS) 1
	Reader $pipe	
    }
}

proc AbortRun { flag } {

    global como
    global como_mess

    if {$flag == "job"} {
	if {$como(PID) > 1 } {
	    catch {exec kill -1 $como(PID)}
	}
	set como(PID) -1
	CloseMess job
    }
    
    if { $flag == "exam"} {
	if {$como(PID) > 1 } {	
	    catch {exec kill -1 $como(PID)}
	}
	set como(PID) -1
	destroy $como_mess
	
    }
}


proc FinishJob { flag } {

    exec touch como.fin
}

proc RunScript { } {

    global como
    global como_messages_text
    global como_mess
    global pipe

    if { ![file exists $como(COMOBIN)]} {

	tk_messageBox -icon error -message "Como binary not found!"\
		-title "ComoUI Error" -type ok
 	return   
    }
	

    set como(PID) [exec $como(COMOBIN) < como.inp > $como(ROOTNAME).log &]

    set pipe [open "| tail -f $como(ROOTNAME).log" r]
    fileevent $pipe readable [list Reader $pipe]
    fconfigure $pipe -blocking 0

    #como run messages window
    set como_mess [toplevel .como_messages]
    wm title .como_messages "Como Messages"
    set como_messages [frame $como_mess.messages]
    
    set scroll [scrollbar $como_messages.yscroll -command {$como_messages_text\
	    yview} -orient vertical]
    
    set como_messages_text [text $como_messages.text -width 100 -height 40\
	    -yscrollcommand [list $scroll set]]

    set bframe [frame $como_messages.bframe]
    set bframe_dis [button $bframe.dis -text "Close Window"\
	    -command "CloseMess job"]
    set bframe_abort [button $bframe.abort -text "Abort Job & Close"\
	    -command "AbortRun job"]
    set bframe_finish [button $bframe.finish -text "Finish asap"\
	    -command "FinishJob job"]
    pack $bframe_dis $bframe_abort $bframe_finish -side left
    grid $como_messages_text $scroll -sticky news
    grid $bframe -sticky news
    pack $como_messages

}






